#!/usr/bin/perl
use strict;
my $source='../flame.cpp';
my $doc='index.htm';
my $q='';
my %known=();
my %gknown=();
my @nft=();
sub add {
 my ($typ,$k)=@_;
 if ($q=~/<tr[^>]*><td[^>]*>\s*$k\s*<\/td>/) {
#  print "FOUND $typ - $k\n";
  if (!length($known{$typ})) {
   $known{$typ}=$k;
  }
 } else {
#  print "NOT FOUND $typ - $k\n";
  push @nft,"$typ,$k";
 }
 if ($gknown{$k}) {
  foreach ('cmd','var','cfg') {
   if ($known{$_} eq $k) {
    $known{$_}='';
   }
  }
 } else {
  $gknown{$k}=1;  
 }
}


sub emit {
 my ($typ,$ln)=@_;
 if ($ln=~/^[^"]*"([^"]+)"[^"]*$/) { #"
  add($typ,$1);
 } else {
  print "WARNING: $typ : bad line:\n$ln";
 }
}
my $cfgmode=0;
#read doc
open X, "<$doc";
while (my $l=<X>) { $q.=$l;}
close X;

#read src
open X, "<$source";
while (my $l=<X>) {
 if ($l=~m|//variable|i) {
  emit('var',$l);
 } elsif ($l=~m|//command|i) {
  emit('cmd',$l);
 } elsif ($l=~/config cfg\[\]=\{/) {
  $cfgmode=1;
 } elsif ($l=~/\};/ && $cfgmode==1) {
  $cfgmode=2;
 } elsif ($cfgmode==1) {
  emit('cfg',$l);
 }
}

close X;
if ($cfgmode!=2) {
 print "WARNING: no configuration found!\n";
}

sub one {
 my ($x)=@_;
 return "<tr><td valign=top>$x	</td><td>	<font color=red>Bez dokumentace</font>	</td></tr>\n";
}

@nft=sort @nft;
for(my $i=0;$i<@nft;$i++) {
  my ($t,$k)=split(/,/,$nft[$i]);
  my $kn=$known{$t};
  print "INJECTING $t/$k near $kn\n";
  if ($kn=~/./) {
   my $s=one($k);
   if (!($q=~s/(<tr[^>]*><td[^>]*>\s*$kn\s*<\/td><td[^>]*>[\x00-\xff]*?)(<\/table>)/\1$s\2/mi)) {
    print "CANNOT INJECT $t/$k near $kn\n";    
   }
  } else {
   $q.="<!--Appending $t-->\n<table>\n".one($k)."</table>\n";
   $known{$t}=$k;
  }
#  $q=~s///;
}

open X, ">${doc}.new";
print X $q;
close X;
